package org.gcube.portlets.user.geoportaldataentry.client.events;

import org.gcube.application.geoportalcommon.shared.products.ConcessioneDV;

import com.google.gwt.event.shared.GwtEvent;

/**
 * The Class CloneProjectEvent.
 *
 * @author Francesco Mangiacrapa at ISTI-CNR francesco.mangiacrapa@isti.cnr.it
 * 
 *         May 26, 2022
 */
public class CloneProjectEvent extends GwtEvent<CloneProjectEventHandler> {

	/** The type. */
	public static Type<CloneProjectEventHandler> TYPE = new Type<CloneProjectEventHandler>();
	private ConcessioneDV concessione;
	private String newProjectName;
	private boolean publishProject;

	public CloneProjectEvent(ConcessioneDV concessione, String newProjectName, boolean publishProject) {
		this.concessione = concessione;
		this.newProjectName = newProjectName;
		this.publishProject = publishProject;
	}

	/**
	 * Gets the associated type.
	 *
	 * @return the associated type
	 */
	/*
	 * (non-Javadoc)
	 * 
	 * @see com.google.gwt.event.shared.GwtEvent#getAssociatedType()
	 */
	@Override
	public Type<CloneProjectEventHandler> getAssociatedType() {
		return TYPE;
	}

	@Override
	protected void dispatch(CloneProjectEventHandler handler) {
		handler.onCloningProject(this);
	}

	public ConcessioneDV getConcessione() {
		return concessione;
	}

	public String getNewProjectName() {
		return newProjectName;
	}

	public boolean isPublishProject() {
		return publishProject;
	}

}
